## tellico 3.4

=== CMakeLists.txt ===
# FindKF5 requires CMake >= 2.8.12
cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)

project(Tellico)
set(TELLICO_VERSION "3.4")

set(QT_MIN_VERSION "5.4.0")

# FindPoppler was added to ECM in 5.19
find_package(ECM 5.19 REQUIRED NO_MODULE)

if(POLICY CMP0063)
  cmake_policy(SET CMP0063 NEW)
endif(POLICY CMP0063)

# https://gitlab.kitware.com/cmake/community/wikis/doc/cmake/Useful-Variables
# automatically add CMAKE_CURRENT_SOURCE_DIR and CMAKE_CURRENT_BINARY_DIR
# to the include directories in every processed CMakeLists.txt
set(CMAKE_INCLUDE_CURRENT_DIR TRUE)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
                      ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules
                      ${ECM_MODULE_PATH})

#include(ECMAddTests)
#include(ECMMarkNonGuiExecutable)
#include(ECMInstallIcons)
include(ECMAddAppIcon)
include(ECMUninstallTarget)
include(FeatureSummary)

include(KDEInstallDirs)
#include(KDECompilerSettings)
include(KDEFrameworkCompilerSettings)
include(KDECMakeSettings)

############# Options #################

option(ENABLE_CDTEXT       "Enable cdtext" TRUE)
option(ENABLE_WEBCAM       "Enable support for webcams" FALSE)
option(BUILD_FETCHER_TESTS "Build tests which verify data sources" FALSE)
option(USE_KHTML           "Build with KHTML rather than QWebEngine" FALSE)
option(ENABLE_BTPARSE      "Build with bibtex importing using btparse, whether internal or external" TRUE)

# btparse does not compile with msvc
if(ENABLE_BTPARSE AND MSVC)
  set(ENABLE_BTPARSE FALSE)
endif()

include(CheckSymbolExists)
check_symbol_exists(strlwr "string.h" HAVE_STRLWR)
check_symbol_exists(strupr "string.h" HAVE_STRUPR)

find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS
    Core
    Widgets
    Xml
    DBus
    Test
    Network
    PrintSupport
)

find_package(KF5 REQUIRED COMPONENTS
    Archive
    Codecs
    Config
    ConfigWidgets
    CoreAddons
    Crash
    DocTools
    GuiAddons
    IconThemes
    ItemModels
    I18n
    JobWidgets
    KIO
    Solid
    Sonnet
    TextWidgets
    Wallet
    WidgetsAddons
    WindowSystem
    XmlGui
)
if(NOT USE_KHTML)
  find_package(Qt5 ${QT_MIN_VERSION} CONFIG OPTIONAL_COMPONENTS
    WebEngineWidgets
  )
  set_package_properties(Qt5WebEngineWidgets PROPERTIES
    DESCRIPTION "Building with QWebEngine is preferrable to KHTML"
    TYPE OPTIONAL)
endif()
if(USE_KHTML OR NOT Qt5WebEngineWidgets_FOUND)
  set(USE_KHTML ON)
  find_package(KF5KHtml REQUIRED NO_MODULE)
  set_package_properties(KF5Html PROPERTIES
    DESCRIPTION "Building with QWebEngine is preferrable to KHTML")
endif()

find_package(Qt5 ${QT_MIN_VERSION} CONFIG OPTIONAL_COMPONENTS
  Charts
)

include(MacroBoolTo01)

find_package(Gettext REQUIRED)
find_package(LibXml2 REQUIRED)
find_package(LibXslt REQUIRED)

find_package(KF5FileMetaData)
set_package_properties(KF5FileMetaData PROPERTIES
    DESCRIPTION "Support for reading file metadata"
    URL "https://www.kde.org"
    TYPE OPTIONAL)

find_package(KF5NewStuff)
set_package_properties(KF5NewStuff PROPERTIES
    DESCRIPTION "Support for fetching new templates and scripts"
    URL "https://www.kde.org"
    TYPE OPTIONAL)

find_package(KF5Sane)
set_package_properties(KF5Sane PROPERTIES
    DESCRIPTION "Support for adding scanned images to a collection"
    URL "https://www.kde.org"
    TYPE OPTIONAL)
if(KF5Sane_FOUND)
    include_directories(${KF5Sane_INCLUDE_DIR})
endif(KF5Sane_FOUND)

#macro_optional_find_package(KdepimLibs 4.5)
#macro_log_feature(KDEPIMLIBS_FOUND "kdepimlibs" "Support for using the address book and calendar for loans" "https://community.kde.org/PIM" FALSE "4.5.0" "")
#find_package(KdepimLibs 4.5)
#set_package_properties(KdepimLibs PROPERTIES
#    DESCRIPTION "Support for using the address book and calendar for loans"
#    URL "https://community.kde.org/PIM"
#    TYPE OPTIONAL)
if(KDEPIMLIBS_FOUND)
    include_directories(${KDEPIMLIBS_INCLUDE_DIRS})
endif(KDEPIMLIBS_FOUND)

find_package(KF5Cddb)
set_package_properties(KF5Cddb PROPERTIES
    DESCRIPTION "Support for CDDB searches"
    URL "https://invent.kde.org/multimedia/libkcddb"
    TYPE OPTIONAL)

find_package(Taglib)
set_package_properties(Taglib PROPERTIES
    DESCRIPTION "Support for reading multimedia files"
    URL "https://taglib.org"
    TYPE OPTIONAL)
if(TAGLIB_FOUND)
    if(TAGLIB_LIBRARIES)
        # Older taglib
        add_definitions(${TAGLIB_CFLAGS})
        include_directories(${TAGLIB_INCLUDES})
    else()
        set(TAGLIB_LIBRARIES Taglib::Taglib)
    endif()
endif(TAGLIB_FOUND)

find_package(Yaz 2.0)
set_package_properties(Yaz PROPERTIES
    DESCRIPTION "Support for searching z39.50 databases"
    URL "https://www.indexdata.com/resources/software/yaz/"
    TYPE OPTIONAL)
if(Yaz_FOUND)
    include_directories(${Yaz_INCLUDE_DIRS})
endif(Yaz_FOUND)

# FindPoppler is part of ECM >= 5.19
find_package(Poppler COMPONENTS Qt5)

find_package(Exempi 2.0)
set_package_properties(Exempi PROPERTIES
    DESCRIPTION "Support for reading PDF/XMP metadata"
    URL "https://libopenraw.freedesktop.org/exempi/"
    TYPE OPTIONAL)
if(Exempi_FOUND)
    include_directories(${Exempi_INCLUDE_DIRS})
endif(Exempi_FOUND)

if(ENABLE_BTPARSE)
find_package(Btparse)
set_package_properties(Btparse PROPERTIES
    DESCRIPTION "External support for parsing and processing BibTeX data files"
    URL "https://metacpan.org/release/Text-BibTeX"
    TYPE OPTIONAL)
if(Btparse_FOUND)
    include_directories(${Btparse_INCLUDE_DIRS})
    set(TELLICO_BTPARSE_LIBS ${Btparse_LIBRARIES})
else(Btparse_FOUND)
    set(TELLICO_BTPARSE_LIBS btparse-tellico)
endif(Btparse_FOUND)
endif(ENABLE_BTPARSE)

find_package(CDIO)
set_package_properties(CDIO PROPERTIES
    DESCRIPTION "Support for reading cdtext from audio CDs"
    URL "https://www.gnu.org/software/libcdio/"
    TYPE OPTIONAL)
if(CDIO_FOUND)
    include_directories(${CDIO_INCLUDE_DIRS})
endif(CDIO_FOUND)

find_package(Csv 3.0)
set_package_properties(Csv PROPERTIES
    DESCRIPTION "External support for reading CSV files"
    URL "http://sourceforge.net/projects/libcsv/"
    TYPE OPTIONAL)
if(Csv_FOUND)
    include_directories(${Csv_INCLUDE_DIRS})
    set(TELLICO_CSV_LIBS ${Csv_LIBRARIES})
else(Csv_FOUND)
    set(TELLICO_CSV_LIBS csv-tellico)
endif(Csv_FOUND)

# webcam uses libv4l, which only works on Linux for now
# Linux 2.6.38 removed the videodev.h header
# libv4l 0.8.3 includes a compat header for videodev.h
if(ENABLE_WEBCAM)
    if(NOT CMAKE_SYSTEM_NAME MATCHES "Linux")
        message("WARNING: Webcam support is not available on your platform")
        set( ENABLE_WEBCAM FALSE )
    else(NOT CMAKE_SYSTEM_NAME MATCHES "Linux")
        pkg_check_modules(LIBV4L libv4l1>=0.6)
        #macro_log_feature(LIBV4L_FOUND "libv4l" "Support for barcode scanning with a webcam" "https://hansdegoede.livejournal.com/3636.html"  FALSE "" "")
        set_package_properties(LIBV4L PROPERTIES
            DESCRIPTION "Support for barcode scanning with a webcam"
            URL "https://hansdegoede.livejournal.com/3636.html"
            TYPE OPTIONAL)
        if(LIBV4L_FOUND)
            if(LIBV4L_VERSION VERSION_LESS "0.8.3" AND CMAKE_SYSTEM_VERSION VERSION_GREATER "2.6.37")
                message("WARNING: libv4l 0.8.3 or later is required for Linux kernel 2.6.38 or later")
                set( ENABLE_WEBCAM FALSE )
            else(LIBV4L_VERSION VERSION_LESS "0.8.3" AND CMAKE_SYSTEM_VERSION VERSION_GREATER "2.6.37")
                include_directories(${LIBV4L_INCLUDE_DIR})
            endif(LIBV4L_VERSION VERSION_LESS "0.8.3" AND CMAKE_SYSTEM_VERSION VERSION_GREATER "2.6.37")
        else(LIBV4L_FOUND)
            set(ENABLE_WEBCAM FALSE)
        endif(LIBV4L_FOUND)
    endif(NOT CMAKE_SYSTEM_NAME MATCHES "Linux")
endif(ENABLE_WEBCAM)

if(CMAKE_COMPILER_IS_GNUCXX)
#    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wnon-virtual-dtor -Wno-long-long -Wextra -fno-check-new -Woverloaded-virtual")
    # remove -Wno-deprecated when porting to KF5 is more advanced
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wnon-virtual-dtor -Wno-long-long -fno-check-new -Woverloaded-virtual -Wno-deprecated -Wno-deprecated-declarations")
endif(CMAKE_COMPILER_IS_GNUCXX)

#add_definitions(${QT_DEFINITIONS}
#                ${KDE4_DEFINITIONS}
#                ${YAZ_CFLAGS})
add_definitions(-DQT_STL -DQT_NO_CAST_FROM_ASCII -DQT_NO_URL_CAST_FROM_STRING -DQT_USE_QSTRINGBUILDER)
remove_definitions(-DQT_NO_STL)

include_directories(${LIBXML2_INCLUDE_DIR}
                    ${LIBXSLT_INCLUDE_DIR}
                    ${CMAKE_CURRENT_BINARY_DIR}
                    ${Tellico_SOURCE_DIR}/src/config
                    ${Tellico_SOURCE_DIR}/src/3rdparty)

set(TELLICO_DATA_INSTALL_DIR ${KDE_INSTALL_DATADIR}/tellico)

add_subdirectory(src)
add_subdirectory(icons)
add_subdirectory(xslt)
add_subdirectory(doc)

########## Wrap tests results around the tests done within the source

macro_bool_to_01(TAGLIB_FOUND HAVE_TAGLIB)
macro_bool_to_01(Poppler_Qt5_FOUND HAVE_POPPLER)
macro_bool_to_01(Exempi_FOUND HAVE_EXEMPI)
macro_bool_to_01(Yaz_FOUND HAVE_YAZ)
macro_bool_to_01(KF5Sane_FOUND HAVE_KSANE)
macro_bool_to_01(Libkcddb_FOUND HAVE_KCDDB)
macro_bool_to_01(KF5Cddb_FOUND HAVE_KF5KCDDB)
macro_bool_to_01(KDEPIMLIBS_FOUND HAVE_KABC)
macro_bool_to_01(KDEPIMLIBS_FOUND HAVE_KCAL)
macro_bool_to_01(LIBV4L_FOUND HAVE_V4L)
macro_bool_to_01(KF5NewStuff_FOUND ENABLE_KNEWSTUFF3)
macro_bool_to_01(Btparse_FOUND HAVE_LIBBTPARSE)
macro_bool_to_01(CDIO_FOUND HAVE_CDIO)
macro_bool_to_01(Csv_FOUND HAVE_LIBCSV)
macro_bool_to_01(KF5FileMetaData_FOUND HAVE_KFILEMETADATA)
macro_bool_to_01(Qt5Charts_FOUND HAVE_QCHARTS)
macro_bool_to_01(ENABLE_BTPARSE ENABLE_BTPARSE)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

########### install files ###############

install(PROGRAMS org.kde.tellico.desktop DESTINATION ${KDE_INSTALL_APPDIR})
install(FILES tellico.dtd tellico.tips DESTINATION ${TELLICO_DATA_INSTALL_DIR})
install(FILES tellico.xml DESTINATION  ${KDE_INSTALL_MIMEDIR})
install(FILES org.kde.tellico.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR} )

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

find_package(KF5I18n CONFIG REQUIRED)
ki18n_install(po)

  find_package(KF5DocTools CONFIG)
  if(KF5DocTools_FOUND)
    kdoctools_install(po)
  endif()

=== src/charts/CMakeLists.txt ===
########### next target ###############

SET(charts_STAT_SRCS
   barchart.cpp
   chartmanager.cpp
   collectionsizereport.cpp
   groupsummaryreport.cpp
)

add_library(charts STATIC ${charts_STAT_SRCS})

target_link_libraries(charts
    tellicomodels
    Qt5::Charts
)

=== src/fetch/CMakeLists.txt ===
ADD_SUBDIRECTORY( scripts )

########### next target ###############

SET(fetch_STAT_SRCS
   allocinefetcher.cpp
   amazonfetcher.cpp
   amazonrequest.cpp
   animenfofetcher.cpp
   arxivfetcher.cpp
   bedethequefetcher.cpp
   bibliosharefetcher.cpp
   bibsonomyfetcher.cpp
   boardgamegeekfetcher.cpp
   colnectfetcher.cpp
   comicvinefetcher.cpp
   configwidget.cpp
   crossreffetcher.cpp
   dbcfetcher.cpp
   dblpfetcher.cpp
   discogsfetcher.cpp
   doubanfetcher.cpp
   dvdfrfetcher.cpp
   entrezfetcher.cpp
   execexternalfetcher.cpp
   fetcher.cpp
   fetcherinfolistitem.cpp
   fetcherinitializer.cpp
   fetcherjob.cpp
   fetchmanager.cpp
   fetchrequest.cpp
   fetchresult.cpp
   filmasterfetcher.cpp
   gcstarpluginfetcher.cpp
   gcstarthread.cpp
   giantbombfetcher.cpp
   googlebookfetcher.cpp
   googlescholarfetcher.cpp
   hathitrustfetcher.cpp
   ibsfetcher.cpp
   igdbfetcher.cpp
   imdbfetcher.cpp
   isbndbfetcher.cpp
   kinofetcher.cpp
   kinopoiskfetcher.cpp
   kinoteatrfetcher.cpp
   messagehandler.cpp
   messagelogger.cpp
   mobygamesfetcher.cpp
   moviemeterfetcher.cpp
   mrlookupfetcher.cpp
   multifetcher.cpp
   musicbrainzfetcher.cpp
   numistafetcher.cpp
   omdbfetcher.cpp
   openlibraryfetcher.cpp
   springerfetcher.cpp
   srufetcher.cpp
   thegamesdbfetcher.cpp
   themoviedbfetcher.cpp
   tvmazefetcher.cpp
   upcitemdbfetcher.cpp
   videogamegeekfetcher.cpp
   vndbfetcher.cpp
   xmlfetcher.cpp
   z3950connection.cpp
   z3950fetcher.cpp
   )

add_library(fetch STATIC ${fetch_STAT_SRCS})

TARGET_LINK_LIBRARIES(fetch
    newstuff
    utils
    ${TELLICO_BTPARSE_LIBS}
    Qt5::Network
    KF5::Archive
    KF5::IconThemes
    KF5::JobWidgets
    KF5::KIOWidgets
    )

IF(${KF5KIO_VERSION} VERSION_GREATER "5.18.0")
  TARGET_LINK_LIBRARIES(fetch
      KF5::KIOGui
      )
ENDIF(${KF5KIO_VERSION} VERSION_GREATER "5.18.0")

IF( Yaz_FOUND )
  TARGET_LINK_LIBRARIES(fetch ${Yaz_LIBRARIES})
ENDIF( Yaz_FOUND )

########### install files ###############

INSTALL(FILES z3950-servers.cfg DESTINATION ${TELLICO_DATA_INSTALL_DIR} )

=== src/gui/CMakeLists.txt ===
########### next target ###############

SET(gui_STAT_SRCS
   boolfieldwidget.cpp
   choicefieldwidget.cpp
   collectiontypecombo.cpp
   combobox.cpp
   countdelegate.cpp
   datefieldwidget.cpp
   datewidget.cpp
   detailedentryitemdelegate.cpp
   dockwidget.cpp
   drophandler.cpp
   imagefieldwidget.cpp
   imagewidget.cpp
   fieldwidget.cpp
   filterrulewidget.cpp
   filterrulewidgetlister.cpp
   kwidgetlister.cpp
   lineedit.cpp
   linefieldwidget.cpp
   listwidgetitem.cpp
   numberfieldwidget.cpp
   parafieldwidget.cpp
   previewdialog.cpp
   progress.cpp
   ratingdelegate.cpp
   ratingfieldwidget.cpp
   ratingwidget.cpp
   spinbox.cpp
   starrating.cpp
   statusbar.cpp
   stringmapdialog.cpp
   stringmapwidget.cpp
   tablefieldwidget.cpp
   tabwidget.cpp
   treeview.cpp
   urlfieldlogic.cpp
   urlfieldwidget.cpp
   )

add_library(gui STATIC ${gui_STAT_SRCS})

TARGET_LINK_LIBRARIES(gui
    Qt5::Core
    Qt5::Widgets
    Qt5::Gui
    KF5::KIOCore
    KF5::KIOFileWidgets
    KF5::SonnetCore
    KF5::SonnetUi
    KF5::XmlGui
    KF5::I18n
    KF5::TextWidgets
)

IF(USE_KHTML)
  TARGET_LINK_LIBRARIES(gui KF5::KHtml)
  ADD_DEFINITIONS(-DUSE_KHTML=${USE_KHTML})
ELSE()
  TARGET_LINK_LIBRARIES(gui Qt5::WebEngineWidgets)
ENDIF()

IF( KF5Sane_FOUND )
  TARGET_LINK_LIBRARIES(gui KF5::Sane)
ENDIF( KF5Sane_FOUND )

=== src/tests/CMakeLists.txt ===
include(ECMAddTests)
include(ECMMarkNonGuiExecutable)

set(EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR})

# formattest includes fieldformat that include core/tellico_config.h
# which is generated in the build directory
include_directories(${Tellico_BINARY_DIR}/src)

ecm_add_test(entitytest.cpp ../fieldformat.cpp
    TEST_NAME entitytest
    LINK_LIBRARIES Qt5::Test utils config
)

ecm_add_test(comparisontest.cpp
    TEST_NAME comparisontest
    LINK_LIBRARIES Qt5::Test tellicotest tellicomodels
)

ecm_add_test(completiontest.cpp ../fieldcompletion.cpp ../field.cpp ../fieldformat.cpp
    TEST_NAME completiontest
    LINK_LIBRARIES Qt5::Test KF5::Completion utils config
)

ecm_add_test(cuecattest.cpp
    TEST_NAME cuecattest
    LINK_LIBRARIES Qt5::Test utils
)

ecm_add_test(isbntest
    TEST_NAME isbntest
    LINK_LIBRARIES Qt5::Test utils
)

ecm_add_test(lccntest.cpp
    TEST_NAME lccntest.cpp
    LINK_LIBRARIES Qt5::Test utils
)

ecm_add_test(lcctest.cpp ../field.cpp ../fieldformat.cpp
    TEST_NAME lcctest
    LINK_LIBRARIES Qt5::Test tellicomodels
)

ecm_add_test(formattest.cpp ../fieldformat.cpp
    TEST_NAME formattest
    LINK_LIBRARIES Qt5::Test config
)

ecm_add_test(fieldtest.cpp ../field.cpp ../fieldformat.cpp ../gui/urlfieldlogic.cpp
    TEST_NAME fieldtest
    LINK_LIBRARIES Qt5::Test config utils
)

ecm_add_test(imagetest.cpp ../utils/tellico_utils.cpp ../utils/guiproxy.cpp ../utils/cursorsaver.cpp ../fieldformat.cpp
    TEST_NAME imagetest
    LINK_LIBRARIES Qt5::Test KF5::Archive images
)

ecm_add_test(imagejobtest.cpp ../fieldformat.cpp
    TEST_NAME imagejobtest
    LINK_LIBRARIES Qt5::Test  KF5::Archive images
)

ecm_add_test(iso6937test.cpp
    TEST_NAME iso6937test
    LINK_LIBRARIES Qt5::Test utils
)

ecm_add_test(iso5426test.cpp
    TEST_NAME iso5426test
    LINK_LIBRARIES Qt5::Test utils
)

ecm_add_test(newstufftest.cpp ../fieldformat.cpp
    TEST_NAME newstufftest
    LINK_LIBRARIES Qt5::Test newstuff config
)

set(tellicotest_SRCS
    ../collection.cpp
    ../entry.cpp
    ../entrygroup.cpp
    ../entrycomparison.cpp
    ../field.cpp
    ../fieldformat.cpp
    ../filter.cpp
    ../borrower.cpp
    ../collectionfactory.cpp
    ../derivedvalue.cpp
    ../progressmanager.cpp
)

add_library(tellicotest STATIC ${tellicotest_SRCS})
target_link_libraries(tellicotest Qt5::Core Qt5::Gui KF5::I18n KF5::ConfigWidgets)

add_dependencies(tellicotest tellico_config)

set(translatorstest_SRCS
    ../translators/tellicoimporter.cpp
    ../translators/xsltimporter.cpp
    ../translators/textimporter.cpp
    ../translators/dataimporter.cpp
    ../translators/importer.cpp
    ../translators/tellicoxmlreader.cpp
    ../translators/tellico_xml.cpp
    ../translators/xmlstatehandler.cpp
    ../translators/xslthandler.cpp
)

add_library(translatorstest STATIC ${translatorstest_SRCS})
target_link_libraries(translatorstest
    Qt5::Core
    Qt5::Gui
    Qt5::Widgets
    Qt5::Xml
    KF5::I18n
    KF5::Archive
    KF5::KIOWidgets
    KF5::ConfigWidgets
    ${LIBXML2_LIBRARIES}
    ${LIBXSLT_LIBRARIES}
    ${LIBXSLT_EXSLT_LIBRARIES}
)

set(TELLICO_TEST_LIBS
    tellicotest
    collections
    utils
    images
    core
    tellicomodels
    Qt5::Test
    KF5::KIOCore
    KF5::Archive
)

ecm_add_test(collectiontest.cpp
             ../document.cpp
             ../translators/tellicoxmlexporter.cpp
             ../translators/tellicozipexporter.cpp
             ../translators/exporter.cpp
    TEST_NAME collectiontest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest
)

ecm_add_test(documenttest.cpp
             ../document.cpp
             ../translators/tellicoxmlexporter.cpp
             ../translators/tellicozipexporter.cpp
             ../translators/exporter.cpp
    TEST_NAME documenttest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest
)

ecm_add_test(filtertest.cpp
    TEST_NAME filtertest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} gui
)

ecm_add_test(tellicomodeltest.cpp
             modeltest.cpp
             ../document.cpp
             ../translators/tellicoimporter.cpp
             ../translators/dataimporter.cpp
             ../translators/importer.cpp
             ../translators/tellicoxmlexporter.cpp
             ../translators/tellicozipexporter.cpp
             ../translators/exporter.cpp
             ../translators/tellicoxmlreader.cpp
             ../translators/tellico_xml.cpp
             ../translators/xmlstatehandler.cpp
    TEST_NAME tellicomodeltest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS}  ${LIBXML2_LIBRARIES}
)

######################################################

ecm_add_test(adstest.cpp
             ../translators/adsimporter.cpp
             ../translators/importer.cpp
    TEST_NAME adstest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS}
)

ecm_add_test(alexandriatest.cpp
             ../translators/alexandriaimporter.cpp
             ../translators/importer.cpp
             ../translators/alexandriaexporter.cpp
             ../translators/exporter.cpp
    TEST_NAME alexandriatest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS}
)

ecm_add_test(amctest.cpp
             ../translators/amcimporter.cpp
             ../translators/dataimporter.cpp
             ../translators/importer.cpp
    TEST_NAME amctest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS}
)

if(TAGLIB_FOUND)
  ecm_add_test(audiofiletest.cpp
               ../translators/audiofileimporter.cpp
               ../translators/dataimporter.cpp
               ../translators/importer.cpp
      TEST_NAME audiofiletest
      LINK_LIBRARIES ${TELLICO_TEST_LIBS} ${TAGLIB_LIBRARIES}
  )
endif(TAGLIB_FOUND)

ecm_add_test(bibtextest.cpp
             ../translators/bibteximporter.cpp
             ../translators/importer.cpp
             ../translators/bibtexexporter.cpp
             ../translators/exporter.cpp
    TEST_NAME bibtextest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} ${TELLICO_BTPARSE_LIBS}
)

ecm_add_test(bibtexmltest.cpp
             ../translators/bibtexmlimporter.cpp
             ../translators/bibtexmlexporter.cpp
             ../translators/exporter.cpp
    TEST_NAME bibtexmltest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest core
)

ecm_add_test(citetest.cpp
             ../collections/bibtexcollection.cpp
             ../core/filehandler.cpp
    TEST_NAME citetest
    LINK_LIBRARIES Qt5::Test cite tellicotest config images
)

ecm_add_test(ciwtest.cpp
             ../translators/ciwimporter.cpp
             ../translators/importer.cpp
    TEST_NAME ciwtest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS}
)

ecm_add_test(collectorztest.cpp
             ../translators/collectorzimporter.cpp
    TEST_NAME collectorztest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest
)

ecm_add_test(csvtest.cpp
             ../translators/csvparser.cpp
             ../translators/csvexporter.cpp
             ../translators/exporter.cpp
    TEST_NAME csvtest
    LINK_LIBRARIES ${TELLICO_CSV_LIBS} ${TELLICO_TEST_LIBS} translatorstest
)

ecm_add_test(delicioustest.cpp
             ../translators/deliciousimporter.cpp
    TEST_NAME delicioustest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest rtf2html-tellico
)

ecm_add_test(filelistingtest.cpp
             ../translators/filelistingimporter.cpp
             ../translators/xmphandler.cpp
    TEST_NAME filelistingtest
    LINK_LIBRARIES translatorstest ${TELLICO_TEST_LIBS} KF5::Solid #order of libs here is important
)
if(KF5FileMetaData_FOUND)
  target_link_libraries(filelistingtest KF5::FileMetaData)
endif(KF5FileMetaData_FOUND)
if(Exempi_FOUND)
  target_link_libraries(filelistingtest ${Exempi_LIBRARIES})
endif(Exempi_FOUND)

ecm_add_test(gcstartest.cpp
             ../translators/gcstarimporter.cpp
             ../translators/gcstarexporter.cpp
             ../translators/tellicoxmlexporter.cpp
             ../translators/tellicozipexporter.cpp
             ../translators/exporter.cpp
             ../document.cpp
    TEST_NAME gcstartest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest
)

ecm_add_test(goodreadstest.cpp
             ../translators/goodreadsimporter.cpp
    TEST_NAME goodreadstest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest
)

ecm_add_test(griffithtest.cpp
             ../translators/griffithimporter.cpp
    TEST_NAME griffithtest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest
)

ecm_add_test(htmlexportertest.cpp
             ../translators/htmlexporter.cpp
             ../translators/tellicoxmlexporter.cpp
             ../translators/tellicozipexporter.cpp
             ../translators/exporter.cpp
             ../document.cpp
    TEST_NAME htmlexportertest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest
)

ecm_add_test(librarythingtest.cpp
             ../translators/librarythingimporter.cpp
             ../translators/importer.cpp
    TEST_NAME librarythingtest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS}
)

ecm_add_test(modstest.cpp
    TEST_NAME modstest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest
)

ecm_add_test(referencertest.cpp
             ../translators/referencerimporter.cpp
    TEST_NAME referencertest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest
)

ecm_add_test(ristest.cpp
             ../translators/risimporter.cpp
             ../translators/importer.cpp
    TEST_NAME ristest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS}
)

ecm_add_test(tellicoreadtest.cpp
             ../translators/tellicoxmlexporter.cpp
             ../translators/tellicozipexporter.cpp
             ../translators/exporter.cpp
             ../document.cpp
    TEST_NAME tellicoreadtest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest
)

ecm_add_test(vinoxmltest.cpp
             ../translators/vinoxmlimporter.cpp
    TEST_NAME vinoxmltest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest
)

set(fetcherstest_SRCS
    abstractfetchertest.cpp
    ../fetch/fetcher.cpp
    ../fetch/fetcherjob.cpp
    ../fetch/fetchrequest.cpp
    ../fetch/fetchresult.cpp
    ../fetch/fetchmanager.cpp
    ../fetch/messagehandler.cpp
    ../fetch/configwidget.cpp
    ../document.cpp
    ../translators/tellicoxmlexporter.cpp
    ../translators/tellicozipexporter.cpp
    ../translators/exporter.cpp
)

# FetchManager links to SRUFetcher for the default sources
# so have to include everything it needs
set(fetcherstest_SRCS
    ${fetcherstest_SRCS}
    ../fetch/srufetcher.cpp
    ../fetch/xmlfetcher.cpp
    ../gui/lineedit.cpp
    ../gui/combobox.cpp
    ../gui/stringmapwidget.cpp
)

add_library(fetcherstest STATIC ${fetcherstest_SRCS})
target_link_libraries(fetcherstest
    translatorstest
    Qt5::Core
    Qt5::Gui
    Qt5::DBus
    KF5::ConfigCore
    KF5::ConfigGui
    KF5::ConfigWidgets
    KF5::I18n
    KF5::Archive
    KF5::IconThemes
    KF5::XmlGui
    KF5::SonnetCore
    KF5::SonnetUi
    ${LIBXML2_LIBRARIES}
    ${LIBXSLT_LIBRARIES}
    ${LIBXSLT_EXSLT_LIBRARIES}
)
add_dependencies(fetcherstest tellico_config)

if(${KF5KIO_VERSION} VERSION_GREATER "5.18.0")
  target_link_libraries(fetcherstest KF5::KIOGui)
endif(${KF5KIO_VERSION} VERSION_GREATER "5.18.0")

# the PDF importer uses CrossRefFetcher, so include the test near the fetchers section
ecm_add_test(pdftest.cpp
             ../translators/pdfimporter.cpp
             ../translators/xmphandler.cpp
             ../entryupdatejob.cpp
    TEST_NAME pdftest
    LINK_LIBRARIES fetcherstest translatorstest ${TELLICO_TEST_LIBS} #order of libs here is important
)
if(Exempi_FOUND)
  target_link_libraries(pdftest ${Exempi_LIBRARIES})
endif(Exempi_FOUND)
if(Poppler_Qt5_FOUND)
  target_link_libraries(pdftest Poppler::Qt5)
endif(Poppler_Qt5_FOUND)

# fetcher tests from here down
IF(BUILD_FETCHER_TESTS)

ecm_add_test(entryupdatejobtest.cpp
             ../entryupdatejob.cpp
             ../fetch/arxivfetcher.cpp
    TEST_NAME entryupdatejobtest
    LINK_LIBRARIES fetcherstest ${TELLICO_TEST_LIBS}
)

ecm_add_test(allocinefetchertest.cpp
             ../fetch/allocinefetcher.cpp
             ../fetch/execexternalfetcher.cpp
             ../translators/bibteximporter.cpp

=== debian/changelog ===
tellico (3.4-0ubuntu1) impish; urgency=medium

  * New upstream release (3.4)
  * Update tests-no-network.diff
  * Temporarily make build time tests non fatal.
  * Update install files.

 -- Rik Mills <rikmills@kde.org>  Sat, 01 May 2021 12:56:20 +0100

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# The fixfilepath feature causes a build failure, disable it.
export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--no-undefined -Wl,--as-needed
# do not use kdeinit for kio
export KDE_FORK_SLAVES=1

%:
	dh $@ --with kf5,python3

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- \
		-DENABLE_WEBCAM=false

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd obj-* && $(MAKE) install DESTDIR=$(CURDIR)/test_root
	$(eval TESTS_HOME := $(shell mktemp -d --tmpdir tellico-home.XXXXXX))
	mkdir -p "$(TESTS_HOME)/tmp"
	mkdir -p -m 700 "$(TESTS_HOME)/runtime"
	-xvfb-run -a --server-args="-screen 0 1024x768x24+32" dh_auto_test --no-parallel -- XDG_DATA_DIRS=$(CURDIR)/test_root/usr/share:/usr/local/share:/usr/share HOME="$(TESTS_HOME)" TMPDIR="$(TESTS_HOME)/tmp" XDG_RUNTIME_DIR="$(TESTS_HOME)/runtime"
	rm -rf "$(TESTS_HOME)"
endif

override_dh_auto_install:
	dh_auto_install
	# extra copyright notices
	rm -fv debian/tmp/usr/share/tellico/pics/README.*

override_dh_python3:
	dh_python3 -p tellico-scripts --shebang=/usr/bin/python3 /usr/share/tellico/data-sources

## tellico 3.4.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)
 
 project(Tellico)
-set(TELLICO_VERSION "3.4")
+set(TELLICO_VERSION "3.4.1")
 
 set(QT_MIN_VERSION "5.4.0")
 
@@ -288,6 +288,7 @@
 macro_bool_to_01(KF5FileMetaData_FOUND HAVE_KFILEMETADATA)
 macro_bool_to_01(Qt5Charts_FOUND HAVE_QCHARTS)
 macro_bool_to_01(ENABLE_BTPARSE ENABLE_BTPARSE)
+macro_bool_to_01(BUILD_FETCHER_TESTS ENABLE_NETWORK_TESTS)
 
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

=== src/fetch/CMakeLists.txt ===
--- 
+++ 
@@ -58,6 +58,7 @@
    srufetcher.cpp
    thegamesdbfetcher.cpp
    themoviedbfetcher.cpp
+   thetvdbfetcher.cpp
    tvmazefetcher.cpp
    upcitemdbfetcher.cpp
    videogamegeekfetcher.cpp
@@ -78,6 +79,7 @@
     KF5::IconThemes
     KF5::JobWidgets
     KF5::KIOWidgets
+    KF5::ConfigWidgets
     )
 
 IF(${KF5KIO_VERSION} VERSION_GREATER "5.18.0")

=== src/newstuff/CMakeLists.txt ===
########### next target ###############

SET(newstuff_STAT_SRCS
   manager.cpp
   )

qt5_add_dbus_adaptor(newstuff_STAT_SRCS org.kde.tellico.newstuff.xml manager.h Tellico::NewStuff::Manager)

add_library(newstuff STATIC ${newstuff_STAT_SRCS})

TARGET_LINK_LIBRARIES(newstuff
    utils
    Qt5::Core
    Qt5::Gui
    KF5::ConfigCore
    KF5::KIOCore
    KF5::Archive
    )

IF( KF5NewStuff_FOUND )
  if(${ECM_VERSION} STRGREATER "5.57.0")
    INSTALL(FILES tellico-template.knsrc tellico-script.knsrc DESTINATION ${KDE_INSTALL_KNSRCDIR})
  else()
    INSTALL(FILES tellico-template.knsrc tellico-script.knsrc DESTINATION ${KDE_INSTALL_CONFDIR})
  endif()
endif()

=== src/tests/CMakeLists.txt ===
--- 
+++ 
@@ -137,6 +137,7 @@
 
 ecm_add_test(collectiontest.cpp
              ../document.cpp
+             ../utils/mergeconflictresolver.cpp
              ../translators/tellicoxmlexporter.cpp
              ../translators/tellicozipexporter.cpp
              ../translators/exporter.cpp
@@ -259,6 +260,31 @@
              ../translators/deliciousimporter.cpp
     TEST_NAME delicioustest
     LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest rtf2html-tellico
+)
+
+ecm_add_test(fieldwidgettest.cpp
+             ../gui/boolfieldwidget.cpp
+             ../gui/choicefieldwidget.cpp
+             ../gui/datefieldwidget.cpp
+             ../gui/datewidget.cpp
+             ../gui/spinbox.cpp
+             ../gui/linefieldwidget.cpp
+             ../gui/lineedit.cpp
+             ../gui/numberfieldwidget.cpp
+             ../gui/parafieldwidget.cpp
+             ../gui/ratingwidget.cpp
+             ../gui/ratingfieldwidget.cpp
+             ../gui/tablefieldwidget.cpp
+             ../gui/urlfieldwidget.cpp
+             ../gui/urlfieldlogic.cpp
+             ../gui/fieldwidget.cpp
+             ../document.cpp
+             ../fieldcompletion.cpp
+             ../translators/tellicoxmlexporter.cpp
+             ../translators/tellicozipexporter.cpp
+             ../translators/exporter.cpp
+    TEST_NAME fieldwidgettest
+    LINK_LIBRARIES translatorstest ${TELLICO_TEST_LIBS} KF5::XmlGui KF5::SonnetCore KF5::SonnetUi KF5::TextWidgets
 )
 
 ecm_add_test(filelistingtest.cpp
@@ -396,34 +422,3 @@
 
 if(${KF5KIO_VERSION} VERSION_GREATER "5.18.0")
   target_link_libraries(fetcherstest KF5::KIOGui)
-endif(${KF5KIO_VERSION} VERSION_GREATER "5.18.0")
-
-# the PDF importer uses CrossRefFetcher, so include the test near the fetchers section
-ecm_add_test(pdftest.cpp
-             ../translators/pdfimporter.cpp
-             ../translators/xmphandler.cpp
-             ../entryupdatejob.cpp
-    TEST_NAME pdftest
-    LINK_LIBRARIES fetcherstest translatorstest ${TELLICO_TEST_LIBS} #order of libs here is important
-)
-if(Exempi_FOUND)
-  target_link_libraries(pdftest ${Exempi_LIBRARIES})
-endif(Exempi_FOUND)
-if(Poppler_Qt5_FOUND)
-  target_link_libraries(pdftest Poppler::Qt5)
-endif(Poppler_Qt5_FOUND)
-
-# fetcher tests from here down
-IF(BUILD_FETCHER_TESTS)
-
-ecm_add_test(entryupdatejobtest.cpp
-             ../entryupdatejob.cpp
-             ../fetch/arxivfetcher.cpp
-    TEST_NAME entryupdatejobtest
-    LINK_LIBRARIES fetcherstest ${TELLICO_TEST_LIBS}
-)
-
-ecm_add_test(allocinefetchertest.cpp
-             ../fetch/allocinefetcher.cpp
-             ../fetch/execexternalfetcher.cpp
-             ../translators/bibteximporter.cpp

=== debian/changelog ===
tellico (3.4.1-2) unstable; urgency=medium

  * Disable fetchertest for now, as it is seems it tries to do network
    connections; patch tests-disable-fetchertest.diff.

 -- Pino Toscano <pino@debian.org>  Sat, 21 Aug 2021 11:48:56 +0200

tellico (3.4.1-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.6.0, no changes required.
  * Update the build dependencies according to the upstream build system:
    - bump extra-cmake-modules to 5.19.0
    - add libqt5charts5-dev, qtwebengine5-dev, libkf5sonnet-dev, and
      libkf5textwidgets-dev
  * Update the patches:
    - tests-no-network.diff: drop, the tests that may use the network are not
      built anymore by default
  * Stop adding custom LDFLAGS, as they are not needed anymore.
  * Use execute_after_dh_auto_install to avoid invoking dh_auto_install
    manually.
  * Unregister tellico-script.knsrc, and tellico-template.knsrc as conffiles,
    as they are no more in /etc.
  * Few tests require a D-Bus session, so:
    - add the dbus build dependency
    - run dh_auto_test with dbus-run-session
  * Update install files.

 -- Pino Toscano <pino@debian.org>  Sat, 21 Aug 2021 10:17:16 +0200

=== debian/control ===
Source: tellico
Section: kde
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Pino Toscano <pino@debian.org>,
Build-Depends: debhelper-compat (= 13),
 , cmake, extra-cmake-modules (>= 5.19.0~)
 , pkg-config, pkg-kde-tools, qtbase5-dev (>= 5.4.0~),
 , libqt5charts5-dev (>= 5.4.0~),
 , qtwebengine5-dev (>= 5.4.0~) [amd64 arm64 armhf i386 mipsel],
 , libkf5archive-dev
 , libkf5cddb-dev
 , libkf5codecs-dev
 , libkf5config-dev
 , libkf5configwidgets-dev
 , libkf5coreaddons-dev
 , libkf5crash-dev
 , libkf5doctools-dev
 , libkf5filemetadata-dev
 , libkf5guiaddons-dev
 , libkf5khtml-dev
 , libkf5i18n-dev
 , libkf5iconthemes-dev
 , libkf5itemmodels-dev
 , libkf5jobwidgets-dev
 , libkf5kio-dev
 , libkf5newstuff-dev
 , libkf5sane-dev
 , libkf5solid-dev
 , libkf5sonnet-dev
 , libkf5textwidgets-dev
 , libkf5wallet-dev
 , libkf5widgetsaddons-dev
 , libkf5windowsystem-dev
 , libkf5xmlgui-dev
 , libtag1-dev, libyaz-dev, libpoppler-qt5-dev
 , libexempi-dev, libcsv-dev, libbtparse-dev
 , libcdio-dev
 , gettext
 , xvfb, xauth, kio
 , python3:any, dh-python
 , dbus
Build-Conflicts: libqimageblitz-dev
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: https://tellico-project.org/
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/tellico
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/tellico.git

Package: tellico
Breaks: tellico-data (<< 3.1-0.1~)
Replaces: tellico-data (<< 3.1-0.1~)
Architecture: any
Depends: tellico-data (= ${source:Version})
 , tellico-scripts (>= ${source:Version})
 , ${shlibs:Depends}, ${misc:Depends}
Recommends: tellico-doc, kio-extras
Description: Collection manager for books, videos, music, etc
 Tellico is a collection manager for KDE. It includes default collections for
 books, bibliographies, comic books, videos, music, coins, stamps, trading
 cards, and wines.
 .
 Tellico capabilities include:
 .
   * creation of user-defined custom collections with unlimited fields,
   * automatically formatted names,
   * sorting and filtering by any field or property,
   * ISBN validation,
   * full customization for printing or display through XSLT files,
   * import and export of CSV, RIS, BibTeX and BibTeXML files,
   * import data from Amazon, IMDb, CDDB or any US-MARC compliant z39.50 server.
 .
 Tellico files are stored in XML format, avoiding the need for a database
 server, and allowing other software applications to use the data.

Package: tellico-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends: tellico, khelpcenter
Description: Collection manager for books, videos, music, etc [doc]
 Tellico is a collection manager for KDE. It includes default collections for
 books, bibliographies, comic books, videos, music, coins, stamps, trading
 cards, and wines.
 .
 Tellico capabilities include:
 .
   * creation of user-defined custom collections with unlimited fields,
   * automatically formatted names,
   * sorting and filtering by any field or property,
   * ISBN validation,
   * full customization for printing or display through XSLT files,
   * import and export of CSV, RIS, BibTeX and BibTeXML files,
   * import data from Amazon, IMDb, CDDB or any US-MARC compliant z39.50 server.
 .
 Tellico files are stored in XML format, avoiding the need for a database
 server, and allowing other software applications to use the data.
 .
 This package contains the documentation.

Package: tellico-data
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends}
Recommends: tellico
Description: Collection manager for books, videos, music, etc [data]
 Tellico is a collection manager for KDE. It includes default collections for
 books, bibliographies, comic books, videos, music, coins, stamps, trading
 cards, and wines.
 .
 Tellico capabilities include:
 .
   * creation of user-defined custom collections with unlimited fields,
   * automatically formatted names,
   * sorting and filtering by any field or property,
   * ISBN validation,
   * full customization for printing or display through XSLT files,
   * import and export of CSV, RIS, BibTeX and BibTeXML files,
   * import data from Amazon, IMDb, CDDB or any US-MARC compliant z39.50 server.
 .
 Tellico files are stored in XML format, avoiding the need for a database
 server, and allowing other software applications to use the data.
 .
 This package contains the architecture independent files, such data files and
 documentation.

Package: tellico-scripts
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends}
Recommends: tellico
Description: Collection manager for books, videos, music, etc [scripts]
 Tellico is a collection manager for KDE. It includes default collections for
 books, bibliographies, comic books, videos, music, coins, stamps, trading
 cards, and wines.
 .
 Tellico capabilities include:
 .
   * creation of user-defined custom collections with unlimited fields,
   * automatically formatted names,
   * sorting and filtering by any field or property,
   * ISBN validation,
   * full customization for printing or display through XSLT files,
   * import and export of CSV, RIS, BibTeX and BibTeXML files,
   * import data from Amazon, IMDb, CDDB or any US-MARC compliant z39.50 server.
 .
 Tellico files are stored in XML format, avoiding the need for a database
 server, and allowing other software applications to use the data.
 .
 This package contains the scripts to import data from external sources, such
 as websites. As the format of the data may change, these scripts are provided
 as a separate package which can be updated through debian-volatile.

## tellico 3.4.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)
 
 project(Tellico)
-set(TELLICO_VERSION "3.4.1")
+set(TELLICO_VERSION "3.4.2")
 
 set(QT_MIN_VERSION "5.4.0")
 
@@ -22,17 +22,15 @@
                       ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules
                       ${ECM_MODULE_PATH})
 
-#include(ECMAddTests)
-#include(ECMMarkNonGuiExecutable)
-#include(ECMInstallIcons)
 include(ECMAddAppIcon)
 include(ECMUninstallTarget)
 include(FeatureSummary)
 
 include(KDEInstallDirs)
-#include(KDECompilerSettings)
-include(KDEFrameworkCompilerSettings)
 include(KDECMakeSettings)
+include(KDEFrameworkCompilerSettings NO_POLICY_SCOPE)
+set(CMAKE_C_EXTENSIONS OFF)
+set(CMAKE_CXX_EXTENSIONS OFF)
 
 ############# Options #################

=== src/3rdparty/CMakeLists.txt ===
IF( NOT Btparse_FOUND AND ENABLE_BTPARSE )
  ADD_SUBDIRECTORY( btparse )
ENDIF( NOT Btparse_FOUND AND ENABLE_BTPARSE )

IF( NOT Csv_FOUND )
  ADD_SUBDIRECTORY( libcsv )
ENDIF( NOT Csv_FOUND )

ADD_SUBDIRECTORY( rtf2html )

=== debian/changelog ===
tellico (3.4.2-1) unstable; urgency=medium

  * New upstream release.
  * Add the zlib1g-dev build dependency to work around the lack of it in
    libtag1-dev. (Closes: #997291)
  * Drop the breaks/replaces for versions older than Debian Buster.

 -- Pino Toscano <pino@debian.org>  Sat, 13 Nov 2021 18:35:57 +0100

=== debian/control ===
--- 
+++ 
@@ -40,6 +40,8 @@
  , xvfb, xauth, kio
  , python3:any, dh-python
  , dbus
+# missing in libtag1-dev
+ , zlib1g-dev
 Build-Conflicts: libqimageblitz-dev
 Standards-Version: 4.6.0
 Rules-Requires-Root: no
@@ -48,8 +50,6 @@
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/tellico.git
 
 Package: tellico
-Breaks: tellico-data (<< 3.1-0.1~)
-Replaces: tellico-data (<< 3.1-0.1~)
 Architecture: any
 Depends: tellico-data (= ${source:Version})
  , tellico-scripts (>= ${source:Version})

## tellico 3.4.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)
 
 project(Tellico)
-set(TELLICO_VERSION "3.4.2")
+set(TELLICO_VERSION "3.4.3")
 
 set(QT_MIN_VERSION "5.4.0")

=== src/newstuff/CMakeLists.txt ===
--- 
+++ 
@@ -12,6 +12,7 @@
     utils
     Qt5::Core
     Qt5::Gui
+    Qt5::DBus
     KF5::ConfigCore
     KF5::KIOCore
     KF5::Archive

=== debian/changelog ===
tellico (3.4.3-1) unstable; urgency=medium

  * New upstream release.
  * Backport upstream commit 46400b75b4c39ab2eb713bec04f02416c3c1e52b to fix
    the code of an unit test; patch
    upstream_Update-unit-test-for-collection-appending-and-mergin.patch.

 -- Pino Toscano <pino@debian.org>  Mon, 03 Jan 2022 14:13:07 +0100

## tellico 3.4.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)
 
 project(Tellico)
-set(TELLICO_VERSION "3.4.3")
+set(TELLICO_VERSION "3.4.4")
 
 set(QT_MIN_VERSION "5.4.0")

=== xslt/CMakeLists.txt ===
ADD_SUBDIRECTORY( entry-templates )
ADD_SUBDIRECTORY( report-templates )

########### install files ###############

SET(XSLT_FILES
    arxiv2tellico.xsl
    biblioshare2tellico.xsl
    bibtexml2tellico.xsl
    bluray-logo.png
    boardgamegeek2tellico.xsl
    cassette-logo.png
    collectorz2tellico.xsl
    comicvine2tellico.xsl
    cd-logo.png
    crossref2tellico.xsl
    dbc2tellico.xsl
    dblp2tellico.xsl
    delicious2tellico.xsl
    dvd-logo.png
    dvdfr2tellico.xsl
    gcstar2tellico.xsl
    giantbomb2tellico.xsl
    goodreads2tellico.xsl
    griffith2tellico.xsl
    hddvd-logo.png
    MARC21slim2MODS3.xsl
    MARC21slimUtils.xsl
    mods2tellico.xsl
    musicbrainz2tellico.xsl
    pubmed2tellico.xsl
    record-logo.png
    referencer2tellico.xsl
    shadowAlpha.png
    springer2tellico.xsl
    srw2tellico.xsl
    tellico2gcstar.xsl
    tellico2html.js
    tellico2html.xsl
    tellico2onix.xsl
    tellico-by-author.xsl
    tellico-by-title.xsl
    tellico-common.xsl
    tellico-printing.xsl
    UNIMARC2MODS3.xsl
    unixref2tellico.xsl
    vhs-logo.png
    vinoxml2tellico.xsl
    welcome.html
    xmp2tellico.xsl
    )

INSTALL(FILES ${XSLT_FILES} DESTINATION ${TELLICO_DATA_INSTALL_DIR} )

=== src/charts/CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,7 @@
    chartmanager.cpp
    collectionsizereport.cpp
    groupsummaryreport.cpp
+   yeardistributionreport.cpp
 )
 
 add_library(charts STATIC ${charts_STAT_SRCS})

=== src/config/CMakeLists.txt ===
########### next target ###############

SET(config_STAT_SRCS
   tellico_config_addons.cpp
   )

SET(config_KCFG_SRCS
   tellico_config.kcfgc
   )

kconfig_add_kcfg_files(config_STAT_SRCS ${config_KCFG_SRCS})

ADD_CUSTOM_TARGET(tellico_config DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/tellico_config.h)

add_library(config STATIC ${config_STAT_SRCS})

TARGET_LINK_LIBRARIES(config
    Qt5::Core
    KF5::I18n
    KF5::ConfigCore
    KF5::ConfigGui
    KF5::ConfigWidgets
    )

########### install files ###############

INSTALL(FILES   tellico_config.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR} )
INSTALL(FILES   tellico-rename.upd tellico.upd DESTINATION ${KDE_INSTALL_KCONFUPDATEDIR} )

INSTALL(PROGRAMS   tellico-1-3-update.pl tellico-3-4-update.pl DESTINATION ${KDE_INSTALL_KCONFUPDATEDIR} )

=== src/gui/CMakeLists.txt ===
--- 
+++ 
@@ -14,6 +14,7 @@
    imagefieldwidget.cpp
    imagewidget.cpp
    fieldwidget.cpp
+   fieldwidgetfactory.cpp
    filterrulewidget.cpp
    filterrulewidgetlister.cpp
    kwidgetlister.cpp

=== src/tests/CMakeLists.txt ===
--- 
+++ 
@@ -27,13 +27,13 @@
     LINK_LIBRARIES Qt5::Test utils
 )
 
-ecm_add_test(isbntest
+ecm_add_test(isbntest.cpp
     TEST_NAME isbntest
     LINK_LIBRARIES Qt5::Test utils
 )
 
 ecm_add_test(lccntest.cpp
-    TEST_NAME lccntest.cpp
+    TEST_NAME lccntest
     LINK_LIBRARIES Qt5::Test utils
 )

=== debian/changelog ===
tellico (3.4.4-1) unstable; urgency=medium

  * New upstream release.
  * Update the patches:
    - upstream_Update-unit-test-for-collection-appending-and-mergin.patch:
      drop, backported from upstream
  * Mark the xvfb, xauth, kio, and dbus build dependencies as !nocheck, as they
    are needed only when running the test suite by dh_auto_test.
  * Add the tidy build dependency, as it is used in a test.

 -- Pino Toscano <pino@debian.org>  Fri, 18 Feb 2022 08:59:37 +0100

=== debian/control ===
--- 
+++ 
@@ -37,9 +37,10 @@
  , libexempi-dev, libcsv-dev, libbtparse-dev
  , libcdio-dev
  , gettext
- , xvfb, xauth, kio
+ , xvfb <!nocheck>, xauth <!nocheck>, kio <!nocheck>
  , python3:any, dh-python
- , dbus
+ , dbus <!nocheck>
+ , tidy <!nocheck>
 # missing in libtag1-dev
  , zlib1g-dev
 Build-Conflicts: libqimageblitz-dev

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,6 @@
 
 # The fixfilepath feature causes a build failure, disable it.
 export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--no-undefined -Wl,--as-needed
 # do not use kdeinit for kio
 export KDE_FORK_SLAVES=1
 
@@ -24,12 +23,11 @@
 	$(eval TESTS_HOME := $(shell mktemp -d --tmpdir tellico-home.XXXXXX))
 	mkdir -p "$(TESTS_HOME)/tmp"
 	mkdir -p -m 700 "$(TESTS_HOME)/runtime"
-	-xvfb-run -a --server-args="-screen 0 1024x768x24+32" dh_auto_test --no-parallel -- XDG_DATA_DIRS=$(CURDIR)/test_root/usr/share:/usr/local/share:/usr/share HOME="$(TESTS_HOME)" TMPDIR="$(TESTS_HOME)/tmp" XDG_RUNTIME_DIR="$(TESTS_HOME)/runtime"
+	xvfb-run -a --server-args="-screen 0 1024x768x24+32" dbus-run-session dh_auto_test --no-parallel -- XDG_DATA_DIRS=$(CURDIR)/test_root/usr/share:/usr/local/share:/usr/share HOME="$(TESTS_HOME)" TMPDIR="$(TESTS_HOME)/tmp" XDG_RUNTIME_DIR="$(TESTS_HOME)/runtime"
 	rm -rf "$(TESTS_HOME)"
 endif
 
-override_dh_auto_install:
-	dh_auto_install
+execute_after_dh_auto_install:
 	# extra copyright notices
 	rm -fv debian/tmp/usr/share/tellico/pics/README.*
